﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public BANano As BANano
	Public Strings As Map	
End Sub

public Sub LoadLanguageFile(Url As String) 'ignore
	' We make a new promise
	Dim promise As BANanoPromise 'ignore
	' Some vars to hold our results
	Dim json As String
	Dim error As String
 
	' Call the http request
	promise.CallSub(Me, "DoHTTPForUrl", Array(Url))
 
	promise.Then(json)
		' We got it!
		Strings = BANano.FromJson(json)
		' Get the menu part
		Dim menu As Map = Strings.Get("menu")
		' We use SetMenu here to replace the texts, not AddMenu
		Main.SKNavigationBar1.SetMenu("Links", menu.Get("Links"))
'		Main.SKNavigationBar1.SetMenu("NearPlaces", menu.Get("NearPlaces"))
'		Main.SKNavigationBar1.SetMenu("Prices", menu.Get("Prices"))
		Main.SKNavigationBar1.SetMenu("Products", menu.Get("Products"))
		Main.SKNavigationBar1.SetMenu("Console", menu.Get("Console"))
		Main.SKNavigationBar1.SetMenu("Home", menu.Get("Home"))
		' Use the new translations on the current page
		Main.LoadTexts
	promise.Else(error)
		Log(error)	
	promise.end
End Sub

public Sub DoHTTPForUrl(Url As String) As String 'ignore
	' Defining a XMLHttpRequest object
	Dim Request As BANanoObject
	Request.Initialize2("XMLHttpRequest", Null)
	
	' Running a get
	Request.RunMethod("open", Array("GET", Url))
		
	' Defining the onload and onerror callbacks
	Dim event As Map
	' Careful here: we have to use the event name without the 'on' prefix when using AddEventListener
	Request.AddEventListener("load", BANano.CallBack(Me, "OnLoadHTTP", event), True)
	Request.AddEventListener("error", BANano.CallBack(Me, "OnErrorHTTP", event), True)
	
	' Let's do it!
	Request.RunMethod("send", Null)
End Sub

public Sub OnloadHTTP(event As Map)
	' Getting our XmlHttpRequest object again
	Dim Request As BANanoObject = event.Get("target")
	
	' Checking the status
	Dim status As Int = Request.GetField("status").Result
	If status < 200 Or status >= 300 Then
		' Maybe not allowed? Return an error with ReturnElse
		BANano.ReturnElse("Status code was not 200!")
	Else
		' All is fine, return a Then
		BANano.ReturnThen(Request.GetField("response").Result)
	End If
End Sub

public Sub OnErrorHTTP(event As Map)
	' Some other error, return a ReturnElse
	BANano.ReturnElse("Network error")
End Sub